// EinsDlg.h : Header-Datei
//

#if !defined(AFX_EINSDLG_H__7CB350C5_CC88_11D1_9EC7_444553540000__INCLUDED_)
#define AFX_EINSDLG_H__7CB350C5_CC88_11D1_9EC7_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CEinsDlg Dialogfeld

class CEinsDlg : public CDialog
{
// Konstruktion
public:
	void Anzeigen();
	CEinsDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CEinsDlg)
	enum { IDD = IDD_EINS_DIALOG };
	CListBox	m_RANDBesitzer;
	CListBox	m_Umschlag;
	CListBox	m_Vertrauen;
	CListBox	m_Clients;
	int		m_Takt;
	int		m_VerfallRAND;
	int		m_FreieRAND;
	int		m_Person;
	CString	m_Nachricht;
	int		m_Kettentyp;
	BOOL	m_Selbstaendig;
	int		m_GueltigkeitRAND;
	int		m_WertungRAND;
	int		m_GueltigkeitKante;
	int		m_TrustServerSchenkhaeufigkeit;
	int		m_PersonenSchenkhaeufigkeit;
	int		m_StartClients;
	int		m_PersonenMisstrauhaeufigkeit;
	CString	m_Qualifiziert;
	int		m_MaxTeilnehmer;
	int		m_Aktiv;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CEinsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CEinsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonNaechsterTakt();
	afx_msg void OnSelchangeListClients();
	afx_msg void OnButtonVertrauenSchenken();
	afx_msg void OnDblclkListVertrauen();
	afx_msg void OnButtonVertrauenEntziehen();
	afx_msg void OnButtonNachrichtVersenden();
	afx_msg void OnButtonVertrauenskette();
	afx_msg void OnButtonNachrichtLesen();
	afx_msg void OnButtonInitialisieren();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


// Ausgangswerte
#define RANDWERTIGKEIT 10
#define GUELTIGKEITRAND 20
#define GUELTIGKEITKANTE 40
#define TRUSTSERVERSCHENKHAEUFIGKEIT 30
#define PERSONENSCHENKHAEUFIGKEIT 30


// Konstanten fr Datenstrukturen
const int Misstrauen     = -1;
const int Zufaellig      = 0;
const int Kurz           = 1;
const int Verlaesslich   = 2;

const int MaxClients   =   100;


// Verwendete Datentypen
typedef int TID;
typedef int TKey;
typedef int TRAND;
typedef int TVertrauen[MaxClients][MaxClients];
typedef TID TKette[MaxClients];


// Umschlag
class CUmschlag
{
public:
	void Entschluesseln(TKey Schluessel);
	void Verschluesseln(TKey Schluessel);
	void Versandfertig(TKette Kette, int Anzahl);

	// ID des Empfaenger bzw. Absenders
	TID nEmpfaengerID;
	int nAbsenderID;

	// Ist dieser Umschlag nur Transportumschlag ?
	bool bWeiterleiten;
	// eventuelle einfach verkettete Liste
	CUmschlag *Inhalt;
	// eigentliche Nachricht
	CString strNachricht;
};


// Teilnehmer
class CClient
{
public:
	CString LeseNachricht();
	TRAND VersendeRAND();
	void ErledigeTakt();
	void EmpfangeNachricht(CUmschlag Umschlag);
	void EmpfangeRAND(TRAND Rand);
	void NeueSchluessel(TKey Oeffentlich, TKey Privat);
	CClient();
	
	// ID (fortlaufende Nummer)
	TID ID;
	// aktiver Teilnehmer ?
	bool bAktiv;
	// der ffentliche Schlssel
	TKey nOeffentlicherSchluessel;
	// Anzahl noch freier RAND
	int  nFreieRAND;
	// ist Person qualifiziert ?
	bool bQualifiziert;

	// Liste Eingehende Post
	CList <CUmschlag,CUmschlag&> arEingehendePost;
	// Liste Ausgehende Post
	CList <CUmschlag,CUmschlag&> arWeiterleiten;
	// Liste Private Post
	CList <CUmschlag,CUmschlag&> arPrivatePost;
	// Liste der freien RAND
	CList <TRAND,TRAND> arRAND;

protected:
	// Privater Schlssel
	TKey nPrivaterSchluessel;
};


// TrustServer
class CTrustServer
{
public:
	void Initialisieren();
	bool ErmittleVertrauenskette(TID Von, TID An, int Typ, TKette Kette);
	void EntzieheVertrauen(TID Von, TID An);
	void Abmelden(TID ID);
	void SchenkeVertrauen(TID Von, TID An);
	void ErneuereRAND(TID ID, TRAND Rand);
	void ErledigeTakt();
	CTrustServer();
	void Anmelden(int ID, TRAND Rand);
	TKey GeneriereSchluessel();
	
	// max. Anzahl Teilnehmer
	int nMaxTeilnehmer;
	// tatschlich aktive Teilnehmer
	int nAktive;
	// Takt
	int nTakt;
	// Verfallstakte der benutzten RAND der Teilnehmer
	int arVerfallstaktRAND[MaxClients];
	// Verfallstakte der Vertrauensbeziehungen der Teilnehmer, -1 fr Mitrauen
	TVertrauen arVertrauen;
	// schenken Teilnehmer automatisch Vertrauen (bzw. Mitrauen)
	bool bSelbstaendig;
	// Hufigkeit der Teilnehmer RAND zu verschenken
	int nClientsSchenkhaeufigkeit;
	// Hufigkeit einer Mitrauensmeldung
	int nClientsMisstrauhaeufigkeit;
	// Wertigkeit eines RAND (fr verlliche Kette)
	int nRANDWertigkeit;
	// Hufigkeit des TrustServers RAND zu verschenken
	int nSchenkhaeufigkeit;
	// Bestandsdauer einer Kante
	int nDauerKante;
	// Bestandsdauer einer Anmeldung beim Server
	int nDauerRAND;
	// anfngliche Anzahl Teilnehmer, qualifizierte Gruppe
	int nStartClients;

protected:
	int BewerteVertrauen(int Typ, TID Von, TID An);
	void VerschenkeRAND();
	TRAND GeneriereRAND();
};


// Netz
class CNetz
{
public:
	void Initialisieren();
	void EmpfangeNachricht(CUmschlag Umschlag);
	void ErledigeTakt();
	CNetz();

	// alle Teilnehmer
	CClient arClients[MaxClients];
	// Nachrichtenverkehr
	CList <CUmschlag,CUmschlag&> arNachrichten;
};




//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio fgt zustzliche Deklarationen unmittelbar vor der vorhergehenden Zeile ein.

#endif // !defined(AFX_EINSDLG_H__7CB350C5_CC88_11D1_9EC7_444553540000__INCLUDED_)
