// ZweiView.cpp : Implementierung der Klasse CZweiView
//

#include "stdafx.h"
#include "Zwei.h"

#include "ZweiDoc.h"
#include "ZweiView.h"

#include "DialogNeueHalle.h"
#include "DialogGestalten.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZweiView

IMPLEMENT_DYNCREATE(CZweiView, CView)

BEGIN_MESSAGE_MAP(CZweiView, CView)
	//{{AFX_MSG_MAP(CZweiView)
	ON_COMMAND(ID_EDITOR_NEUEHALLE, OnEditorNeuehalle)
	ON_COMMAND(ID_EDITOR_HALLEGESTALTEN, OnEditorHallegestalten)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZweiView Konstruktion/Destruktion

CZweiView::CZweiView()
{
}

CZweiView::~CZweiView()
{
}

BOOL CZweiView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CZweiView Zeichnen

void CZweiView::OnDraw(CDC* pDC)
{
	CZweiDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	int x,y;
	for (x=0; x<pDoc->ptGroesse.X; x++)
		for (y=0; y<pDoc->ptGroesse.Y; y++)
		{
			int nViewX = x*SKALIERUNG;
			int nViewY = y*SKALIERUNG;
			switch(pDoc->arHalle[x][y])
			{
				case GEGENSTAND: 
					pDC->FillSolidRect(nViewX,nViewY,SKALIERUNG,SKALIERUNG,RGB(0,0,255)); break;
				case WEGSPUR:    
					pDC->FillSolidRect(nViewX,nViewY,SKALIERUNG,SKALIERUNG,RGB(255,0,0)); break;
				case ROY:        
					pDC->FillSolidRect(nViewX,nViewY,SKALIERUNG,SKALIERUNG,RGB(0,255,0)); break;
				case UNSICHTBAR:        
					pDC->FillSolidRect(nViewX,nViewY,SKALIERUNG,SKALIERUNG,RGB(250,250,250)); break;
				default:        
					pDC->FillSolidRect(nViewX,nViewY,SKALIERUNG,SKALIERUNG,RGB(230,230,230));
					if (((x%5)==0)&&((y%5)==0))
						pDC->FillSolidRect(nViewX,nViewY,1,1,RGB(0,0,0));
			}
		}

	pDC->FillSolidRect(pDoc->ptStart.X*SKALIERUNG,pDoc->ptStart.Y*SKALIERUNG,SKALIERUNG,SKALIERUNG,RGB(0,150,0)); 
	pDC->FillSolidRect(pDoc->ptZiel.X*SKALIERUNG,pDoc->ptZiel.Y*SKALIERUNG,SKALIERUNG,SKALIERUNG,RGB(0,0,0)); 
}

/////////////////////////////////////////////////////////////////////////////
// CZweiView Diagnose

#ifdef _DEBUG
void CZweiView::AssertValid() const
{
	CView::AssertValid();
}

void CZweiView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CZweiDoc* CZweiView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CZweiDoc)));
	return (CZweiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CZweiView Nachrichten-Handler

void CZweiView::OnEditorNeuehalle() 
{
	CDialogNeueHalle dlg;
	CZweiDoc *pDoc = GetDocument();

	dlg.m_Breite = pDoc->ptGroesse.X;
	dlg.m_Hoehe = pDoc->ptGroesse.Y;

	if (dlg.DoModal()==IDOK)
	{
		pDoc->ptGroesse.X = dlg.m_Breite;
		pDoc->ptGroesse.Y = dlg.m_Hoehe;
	}
}

void CZweiView::OnEditorHallegestalten() 
{
	CDialogGestalten dlg;
	CZweiDoc *pDoc = GetDocument();

	dlg.m_StartX = pDoc->ptStart.X;
	dlg.m_StartY = pDoc->ptStart.Y;
	dlg.m_ZielX = pDoc->ptZiel.X;
	dlg.m_ZielY = pDoc->ptZiel.Y;
	dlg.m_Schritte = pDoc->nZuege;
	memcpy(dlg.m_Halle,pDoc->arHalle,sizeof(THalle));

	if (dlg.DoModal()==IDOK)
	{
		pDoc->ptStart.X = dlg.m_StartX;
		pDoc->ptStart.Y = dlg.m_StartY;
		pDoc->ptZiel.X = dlg.m_ZielX;
		pDoc->ptZiel.Y = dlg.m_ZielY;
		pDoc->nZuege = dlg.m_Schritte;
		memcpy(pDoc->arHalle,dlg.m_Halle,sizeof(THalle));

		pDoc->SetModifiedFlag();
		Invalidate(TRUE);
	}
}

